/*
   ** Copyright (C) 1995  Jonathan Paul Griffiths.  All rights reserved.
   **
   ** You may do anything with this code you wish EXCEPT sell it. You may sell
   ** any software you create using this code,  but you MUST NOT charge for
   ** the code itself.  See the file "jlib.doc" for detailed terms. 
 */
#include <jlib.h>


void jlib_default_exit_function(char *message);

exit_function __jlib_error_handler = jlib_default_exit_function;


/* set an exit function to be called on library errors */
void jlib_set_exit_function(exit_function funct)
{
 __jlib_error_handler = funct;
}


/* call the library fault routine */
void jlib_exit(char *message)
{
 
 if(__jlib_error_handler == NULL){
   JLIB_PRINT_DEBUG_INFO ("Calling default exit function...\n");
   jlib_default_exit_function(message);
 }
 else{
   JLIB_PRINT_DEBUG_INFO ("Calling custom exit function...\n");
    __jlib_error_handler(message);
 }
}


/* default - Exit from jlib and print an error message */
void jlib_default_exit_function(char *message)
{
#if KEYBOARD_AVAILABLE == 1
 kb_closedown();
#endif

#if MOUSE_AVAILABLE == 1
 mouse_closedown();
#endif

 screen_restore_video_mode();

 puts("JLib:  Exiting due to internal error:");
 puts(message);
 
 exit(0);
}
