/*
** Copyright (C) 1995  Jonathan Paul Griffiths.  All rights reserved.
**
** You may do anything with this code you wish EXCEPT sell it. You may sell
** any software you create using this code,  but you MUST NOT charge for
** the code itself.  See "jlib.doc" for more details.
*/

#include <jlib.h>
#include <grx20.h>

/*+------------------------------------------------------------------------+*/
/*|blit a fullscreen buffer to the screen                                  |*/
/*+------------------------------------------------------------------------+*/
/*|This routine is just a normal blit that assumes the buffer is the same  |*/
/*|size as the screen.                                                     |*/
/*+------------------------------------------------------------------------+*/

JINLINE void screen_blit_fs_buffer(buffer_rec *buff)
{
 /* 'fake' the blit as a context to context blit */

  /* replace thier pointers with pointers to our own data */
 __jlib_fake_context->gc_baseaddr[0] = B_BUFF_PTR(buff);

 GrBitBltNC(NULL,0,0,__jlib_fake_context,0,0,SCREEN_MAX_X,SCREEN_MAX_Y,GrWRITE);

}


/*+------------------------------------------------------------------------+*/
/*|blit part of a buffer to the screen without clipping.                   |*/
/*+------------------------------------------------------------------------+*/
/* this routine needs optimising - I might get to it when the libgrx internals
** are stable enough for me to hard code the grx routines I currently call,
** without some of the stuff we don't need done - jpg
*/
void screen_blit_buff_toNC(int x,int y,buffer_rec *sbuff,
			  int sbx1, int sby1,int sbx2, int sby2)
{
 char *ourmem[4];

 ourmem[0] = B_BUFF_PTR(sbuff);

 /*
 ourmem[1] = B_BUFF_PTR(sbuff);
 ourmem[2] = B_BUFF_PTR(sbuff);
 ourmem[3] = B_BUFF_PTR(sbuff);
 */

 /* fill in the correct details for the blit */
 GrCreateFrameContext(GR_frameRAM8,B_X_SIZE(sbuff),B_Y_SIZE(sbuff),ourmem,__jlib_fake_partial_context);

 __jlib_fake_partial_context->gc_lineoffset = GrLineOffset(B_X_SIZE(sbuff));

 GrBitBltNC(NULL,x,y,__jlib_fake_partial_context,sbx1,sby1,sbx2,sby2,GrWRITE);
}


/*+------------------------------------------------------------------------+*/
/*|blit part of a buffer to the screen with clipping.                      |*/
/*+------------------------------------------------------------------------+*/

void screen_blit_buff_to(int x,int y,buffer_rec *sbuff,
			 int sbx1, int sby1,int sbx2, int sby2)
{
 char *ourmem[4];

 ourmem[0] = B_BUFF_PTR(sbuff);

 /*
 ourmem[1] = B_BUFF_PTR(sbuff);
 ourmem[2] = B_BUFF_PTR(sbuff);
 ourmem[3] = B_BUFF_PTR(sbuff);
 */

 /* fill in the correct details for the blit */
 GrCreateFrameContext(GR_frameRAM8,B_X_SIZE(sbuff),B_Y_SIZE(sbuff),ourmem,__jlib_fake_partial_context);
 
 __jlib_fake_partial_context->gc_lineoffset = GrLineOffset(B_X_SIZE(sbuff));

 /* blit using grx */
 GrBitBlt(NULL,x,y,__jlib_fake_partial_context,sbx1,sby1,sbx2,sby2,GrWRITE);
}

