/*
** Copyright (C) 1995  Jonathan Paul Griffiths.  All rights reserved.
**
** You may do anything with this code you wish EXCEPT sell it. You may sell
** any software you create using this code,  but you MUST NOT charge for
** the code itself.  See the file "jlib.doc" for more details.
*/

		  /* THE FOLLOWING CODE IS DJGPP SPECIFIC */

#include <dos.h>
#include <stdlib.h>
#include <grx20.h>
#include <jlib.h>

char version_string[] = "djgpp V2 (DPMI) grx2.0";

GrContext *__jlib_fake_context;  /* used for blits */
GrContext *__jlib_fake_partial_context;
int __jlib_planesize;

int _jlib_dos_selector;  /* global selector for dos memory */

static int __jlib_previous_mode;  /* holds previous mode */
extern int __jlib_mouse_present;

/* define this here to save us including old compatable header */
#define make_fake_context(w,h,mem,where) (                                        \
    GrCreateFrameContext(                                                       \
	GR_frameRAM8,                                                      \
	(w),(h),                                                \
	(char **)0                                                      \
	,                                                              \
	(where)                                                         \
    )                                                                           \
)

/* set mode and initialise fake context */
int screen_set_video_mode(void)
{
 int i;

 __jlib_previous_mode = GrCurrentMode(); /* save current mode */

 if(GrSetMode(GR_width_height_color_graphics,SCREEN_WIDTH,SCREEN_HEIGHT,SCREEN_NUM_COLORS)==0){
    return 0;
 }

  __jlib_planesize  = GrFramePlaneSize(GrCoreFrameMode(),SCREEN_WIDTH,SCREEN_HEIGHT);

  if(__jlib_planesize <= 0L) return(0);
  /* should possibly check upper bound of plane size here */

 __jlib_fake_context = make_fake_context(SCREEN_WIDTH,SCREEN_HEIGHT,NULL,NULL);
 
 if(__jlib_fake_context == NULL){
    JLIB_PRINT_DEBUG_INFO("Couldn't initialise context.\n");
    return 0;
 }

 __jlib_fake_partial_context = calloc(1,sizeof(GrContext));

 if(__jlib_fake_partial_context == NULL){
    JLIB_PRINT_DEBUG_INFO("Couldn't initialise context.\n");
    return 0;
 }

 /* free the memory grx allocated */
 for(i=0;i<4;i++){
     if(__jlib_fake_context->gc_baseaddr[0] != NULL){
       free(__jlib_fake_context->gc_baseaddr[0]);
     }
 }

__jlib_mouse_present = GrMouseDetect();

 if(__jlib_mouse_present){
    GrMouseEventMode(0);  /* use polled mode */
    GrMouseInit();
    GrMouseEventEnable(0,1); /* don't enable keyboard events */
    GrMouseEraseCursor();
 }

 return 1; /* mode set ok */
}


/* restore text mode */
void screen_restore_video_mode(void)
{
 GrSetMode(__jlib_previous_mode);

}

/*+------------------------------------------------------------------------+*/
/*|Return the current page number ( always 1 in this case)                 |*/
/*+------------------------------------------------------------------------+*/

int screen_get_page(void)
{
 return 1;
}

/*+------------------------------------------------------------------------+*/
/*|Show the current drawing page. ( Has no effect in this mode.)           |*/
/*+------------------------------------------------------------------------+*/

void screen_show_page(int page)
{
 /* do nothing */
}

void screen_set_page(page)
{
}



void screen_wait_vsync(void)
{
 /* not supported yet */
}


/*+------------------------------------------------------------------------+ */ 
/*|Fill the screen with a given color                                      | */ 
/*+------------------------------------------------------------------------+ */ 

void screen_fill (UBYTE color) 
{
 GrClearScreen((int)color);

}


/*+------------------------------------------------------------------------+ */
/*|Clear the screen.                                                       | */
/*+------------------------------------------------------------------------+ */ 

void screen_clear (void) 
{
 GrClearScreen(0);

}


