/*
**
** Copyright (C) 1995  Jonathan Paul Griffiths.  All rights reserved.
**
** You may do anything with this code you wish EXCEPT sell it. You may sell
** any software you create using this code,  but you MUST NOT charge for
** the code itself.  See the file "jlib.doc" for more details.
*/

#include <grx20.h>
#include <jlib.h>


static int __jlib_mouse_initted = 0;
int __jlib_mouse_present;


/*+--------------------------------------------------------------------------+*/
/*|check for the presence of a Mouse.                                        |*/
/*+--------------------------------------------------------------------------+*/
/*|this routine should always be called FIRST to initialize the mouse        |*/
/*+--------------------------------------------------------------------------+*/
int mouse_present(void)
{
 if(__jlib_mouse_initted != 0){
    return 1;
 }
 
 __jlib_mouse_initted = 1;
 
 if(__jlib_mouse_present){
    GrMouseDisplayCursor();

    return MOUSE_PRESENT;
 }
 else{
    return MOUSE_ABSENT;
 }

}


/*+--------------------------------------------------------------------------+*/
/*|shut down the mouse                                                       |*/
/*+--------------------------------------------------------------------------+*/
void mouse_closedown(void)
{
 if(__jlib_mouse_initted == 0){
    return;
 }
 
 __jlib_mouse_initted = 0;

 GrMouseEraseCursor();

}

/*+--------------------------------------------------------------------------+*/
/*|show the pointer                                                          |*/
/*+--------------------------------------------------------------------------+*/
void mouse_show_pointer(void)
{
 if(__jlib_mouse_initted == 0){
    return;
 }

 GrMouseDisplayCursor();

}


/*+--------------------------------------------------------------------------+*/
/*|hide the pointer                                                          |*/
/*+--------------------------------------------------------------------------+*/
void mouse_hide_pointer(void)
{
 if(__jlib_mouse_initted == 0){
    return;
 }

 GrMouseEraseCursor();
}


/*+--------------------------------------------------------------------------+*/
/*|read pointer coordinates                                                  |*/
/*+--------------------------------------------------------------------------+*/
void mouse_get_status(int *x_pos, int *y_pos, int *b_status)
{
 GrMouseEvent event;

 if(__jlib_mouse_initted == 0){
    return;
 }


 GrMouseGetEvent((GR_M_MOTION|GR_M_BUTTON_CHANGE|GR_M_POLL|GR_M_NOPAINT ),&event);

 *x_pos = event.x;
 *y_pos = event.y;
 *b_status = event.buttons;

}

/*+--------------------------------------------------------------------------+*/
/*|change pointer coordinates                                                |*/
/*+--------------------------------------------------------------------------+*/
void mouse_set_status( int x, int y)
{

 if(__jlib_mouse_initted == 0){
    return;
 }

 GrMouseWarp(x,y);
 
}


