/****************************************************************************
 This file is based on keyboard handling code from "Allegro",  a low-level
 gaming library for djgpp V2. I have butchered the code a little.
 Allegro is authored by:

Shawn Hargreaves,
1 Salisbury Road,
Market Drayton,
Shropshire,
England TF9 1AJ
email slh100@tower.york.ac.uk (until july 1996)

 And is available by anonymous ftp from x2ftp.oulu.fi in the directory:
 /pub/msdos/programming/djgpp2

 Here is what Shawn has to say regarding copyright,  etc.. 

   4: What about copyright issues?
   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   Allegro is swap-ware. You may use, modify, redistribute, and generally 
   hack it about in any way you like, but if you do you must send me 
   something in exchange. This could be a complimentary copy of a game, an 
   addition or improvement to Allegro, a bugfix, some money (this is 
   particularly encouraged if you use Allegro in a commercial product), or 
   just a copy of your autoexec.bat if you don't have anything better. If 
   you redistribute parts of Allegro or make a game using it, it would be 
   nice if you mentioned me somewhere in the credits, but if you just want 
   to pinch a few routines that is OK too. I'll trust you not to rip me off.

  There you go,  enjoy!
****************************************************************************/

#include <stdlib.h>
#include <go32.h>
#include <ctype.h>
#include <dpmi.h>
#include <sys/segments.h>
#include <signal.h>
#include <dos.h>
#include <conio.h>
#include <bios.h>
#include <jlib.h>

#define KEY_BUFFER_SIZE 256
#define KEY_LSHIFT      42
#define KEY_RSHIFT      54
#define KEY_CAPSLOCK    58

int lock_memory(void *ptr, int size, int code);
int lock_memory(void *ptr, int size, int code)
{
   __dpmi_meminfo meminfo;
   int seg = (code ? _my_cs() : _my_ds());

   if (__dpmi_get_segment_base_address(seg, &meminfo.address) != 0){
      return -1;
   }

   meminfo.size = size;
   meminfo.address += (long)ptr;
   return __dpmi_lock_linear_region(&meminfo);
}

static char key_asc_table[128] =
{
   0,  27, '1','2','3','4','5','6','7','8','9','0','-','=',8,  9,     
   'q','w','e','r','t','y','u','i','o','p','[',']',13, 0,  'a','s',
   'd','f','g','h','j','k','l',';',39, '`',0,  92, 'z','x','c','v',
   'b','n','m',',','.','/',0,  '*',0,  ' ',0,  0,  0,  0,  0,  0,     
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  '-',0,  0,  0,  '+',0,     
   0,  0,  0,  127,0,  0,  92, 0,  0,  0,  0,  0,  0,  0,  0,  0,     
   13, 0,  '/',0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  127,   
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0     
};

static char key_shift_table[128] =
{
   0,  27, '!','@','#','$','%','^','&','*','(',')','_','+',8,  9,     
   'Q','W','E','R','T','Y','U','I','O','P','{','}',13, 0,  'A','S',   
   'D','F','G','H','J','K','L',':',34, '~',0,  '|','Z','X','C','V',   
   'B','N','M','<','>','?',0,  '*',0,  ' ',0,  0,  0,  0,  0,  0,     
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  '-',0,  0,  0,  '+',0,     
   0,  0,  0,  127,0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   13, 0,  '/',0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  127,
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0     
};

static char key_caps_table[128] =
{
/* 0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F           */
   0,  27, '1','2','3','4','5','6','7','8','9','0','-','=',8,  9,     /* 0 */
   'Q','W','E','R','T','Y','U','I','O','P','[',']',13, 0,  'A','S',   /* 1 */
   'D','F','G','H','J','K','L',';',39, '`',0,  92, 'Z','X','C','V',   /* 2 */
   'B','N','M',',','.','/',0,  '*',0,  ' ',0,  0,  0,  0,  0,  0,     /* 3 */
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  '-',0,  0,  0,  '+',0,     /* 4 */
   0,  0,  0,  127,0,  0,  92, 0,  0,  0,  0,  0,  0,  0,  0,  0,     /* 5 */
   13, 0,  '/',0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  127,   /* 6 */
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0      /* 7 */
};

int _keyboard_installed = 0;
unsigned _keyboard_shiftstate;
volatile char key[128];                   /* key pressed flags */
static volatile int key_buffer[KEY_BUFFER_SIZE]; 
static volatile unsigned char key_buffer_start = 0;
static volatile unsigned char key_buffer_end = 0;
static _go32_dpmi_seginfo key_oldint;   /* original prot-mode key IRQ */
static _go32_dpmi_seginfo key_int;      /* prot-mode interrupt segment info */


void kb_clear(void)
{
 unsigned int i,*k;

 k=(int *)&key;

 for(i=32;i!=0;i--){
     *k=0;
     ++k;
 }     
 key_buffer_start = key_buffer_end = 0;
}

int kb_key_hit(void)
{
   return (key_buffer_start != key_buffer_end);
}

int kb_keydown(int keynum)
{
   if((!_keyboard_installed)||((keynum < 0) || (keynum >= 128))){
      return 0;
   }
   return key[keynum];
}

char kb_get_next_key(void)
{
   char c;

   if (!_keyboard_installed){
      return 0;
   }

   do {
   } while (key_buffer_start == key_buffer_end);  /* wait for a press */

   disable();
   c = key_buffer[key_buffer_start];
   key_buffer_start++;      /* autowrap the unsigned char */
   enable();

   return c;
}

static void my_keyint()
{
   int temp = inportb(0x60);     /* read keyboard byte */

   if (temp & 0x80) {            /* key was released */
      key[temp&0x7f] = 0; 
   }
   else {                        /* key was pressed */
      temp &= 0x7f;
      key[temp] = 1;

      if (key_asc_table[temp]!=0){
           if ((key[KEY_LSHIFT]) || (key[KEY_RSHIFT])){
               key_buffer[key_buffer_end] = key_shift_table[temp];
           }
           else{
               if(_keyboard_shiftstate){
                  key_buffer[key_buffer_end] = key_caps_table[temp];
               }
               else{
                  key_buffer[key_buffer_end] = key_asc_table[temp];
               }
           }
           key_buffer_end++; /* autowraps */

           if (key_buffer_end == key_buffer_start) {    /* buffer full */
               key_buffer_start++;
           }
      }
      else{
         if(temp==KEY_CAPSLOCK){
            /* caps lock pressed or released */
            _keyboard_shiftstate = (!_keyboard_shiftstate);   /* flip shift state */
         }
      }
   }

   outportb(0x20,0x20);       /* ack. the interrupt */
}
static int my_keyint_end;

void kb_init(void)
{
 if(_keyboard_installed){
    return;
 }

 if(_bios_keybrd(_KEYBRD_SHIFTSTATUS)&64){    /* determine shift status */
    _keyboard_shiftstate=1;
 }

 lock_memory((void *)&key, sizeof(key), 0);
 lock_memory((void *)&key_asc_table, 128, 0);
 lock_memory((void *)&key_shift_table, 128, 0);
 lock_memory((void *)&key_caps_table, 128, 0);
 lock_memory((void *)&key_buffer, 256, 0);
 lock_memory((void *)&key_buffer_start, sizeof(key_buffer_start), 0);
 lock_memory((void *)&key_buffer_end, sizeof(key_buffer_end), 0);
 lock_memory((void *)&_keyboard_installed, sizeof(_keyboard_installed), 0);
 lock_memory((void *)&_keyboard_shiftstate, sizeof(_keyboard_shiftstate), 0);
 lock_memory(my_keyint, (int)my_keyint_end - (int)my_keyint, 1);

 kb_clear();
 fflush(stdin);

 key_int.pm_offset = (int)my_keyint;       /* pm handler */
 _go32_dpmi_allocate_iret_wrapper(&key_int);
 key_int.pm_selector = _go32_my_cs();
 _go32_dpmi_get_protected_mode_interrupt_vector(9, &key_oldint);
 _go32_dpmi_set_protected_mode_interrupt_vector(9, &key_int);

 _keyboard_installed=1;
}

void kb_closedown(void)
{
   if (!_keyboard_installed){
      return;
   }
   _go32_dpmi_set_protected_mode_interrupt_vector(9, &key_oldint);
   _go32_dpmi_free_iret_wrapper(&key_int);
   _keyboard_installed = 0;
}

