
/*
   ** Copyright (C) 1995  Jonathan Paul Griffiths.  All rights reserved.
   **
   ** You may do anything with this code you wish EXCEPT sell it. You may sell
   ** any software you create using this code,  but you MUST NOT charge for
   ** the code itself.  See the file "jlib.doc" for details.
 */

		  /* THE FOLLOWING CODE IS SVGALIB SPECIFIC */

#include <jlib.h>
#include <vga.h>
#include <vgagl.h>


char version_string[] = "Linux svgalib";
int __jlib_pages;
vga_modeinfo *__jlib_modeinfo;


/*+------------------------------------------------------------------------+ */
/*|set video mode                                                          | */
/*+------------------------------------------------------------------------+ */
int screen_set_video_mode (void)
{ 
 
 if (!vga_hasmode(JLIB_MODE)){
     return 0;
 } 

 __jlib_modeinfo=vga_getmodeinfo(JLIB_MODE);
 __jlib_pages=(__jlib_modeinfo->height*__jlib_modeinfo->linewidth+65535)>>16;
 
 if(!vga_init ()){
     if(!vga_setmode (JLIB_MODE)){
        return 1; /* mode set successful */
     }
 }

 return 0; /* mode set failed */
}


/*+------------------------------------------------------------------------+ */
/*|restore the text mode.                                                  | */
/*+------------------------------------------------------------------------+ */
void screen_restore_video_mode (void)
{
   vga_setmode (TEXT);
}

/*+------------------------------------------------------------------------+ */
/*|Return the current page number ( always 1 in this case)                 | */
/*+------------------------------------------------------------------------+ */
int screen_get_page (void)
{
   return 1;
}

/*+------------------------------------------------------------------------+ */
/*|set the given  page number (no-op here)                                 | */
/*+------------------------------------------------------------------------+ */
void screen_set_page (int page)
{
 /* do nothing */
}

/*+------------------------------------------------------------------------+ */
/*|Show the current drawing page. ( Has no effect in this mode.)           | */
/*+------------------------------------------------------------------------+ */
void screen_show_page (int page)
{
   /* do nothing */
}


void screen_wait_vsync (void)
{
   /* not implememted yet */
}


/*+------------------------------------------------------------------------+ */ 
/*|Fill the screen with a given color                                      | */ 
/*+------------------------------------------------------------------------+ */ 

void screen_fill (UBYTE color) 
{
 int i;

 for(i=0;i<__jlib_pages;i++){
     vga_setpage(i);
 
     memset(vga_getgraphmem(),color,65536); 
 }

}


/*+------------------------------------------------------------------------+ */ 
/*|Clear the screen.                                                       | */ 
/*+------------------------------------------------------------------------+ */ 

void screen_clear (void) 
{
 screen_fill(0);
}
