/*
** Copyright (C) 1995  Jonathan Paul Griffiths.  All rights reserved.
**
** You may do anything with this code you wish EXCEPT sell it. You may sell
** any software you create using this code,  but you MUST NOT charge for
** the code itself.  Charging a distribution fee for this code is also
** FORBIDDEN.
*/

/* WATCOM */

#include <jlib.h>
#include <stdio.h>

void screen_blit_fs_buffer (buffer_rec * buff)
{
 FAST_LONG_COPY(buff->buffer,(int*)MODE_13H_START,64000);
}

void screen_blit_buff_toNC (int x, int y, buffer_rec * sbuff,
			 int sbx1, int sby1, int sbx2, int sby2)
{
   unsigned int sbuffx = B_X_SIZE (sbuff);
   UBYTE *src = B_BUFF_PTR (sbuff) + (sbuffx * sby1) + sbx1;
   UBYTE *dest = (UBYTE *) MODE_13H_START + (y * SCREEN_WIDTH) + x;
   unsigned int h_len = sbx2 - sbx1+1;
   unsigned int v_iterations = sby2 - sby1+1;

   for (; v_iterations != 0; v_iterations--){
             FAST_SHORT_COPY(src, dest, h_len);
	     src += sbuffx;
	     dest += SCREEN_WIDTH;
   }
}

/*+------------------------------------------------------------------------+ */
/*|blit part of a buffer to the screen with clipping.                      | */
/*+------------------------------------------------------------------------+ */

void screen_blit_buff_to (int x, int y, buffer_rec * sbuff,
			  int sbx1, int sby1, int sbx2, int sby2)
{
   unsigned int sbuffx = B_X_SIZE (sbuff);
   UBYTE *src = B_BUFF_PTR (sbuff);
   UBYTE *dest = (UBYTE *) MODE_13H_START;
   unsigned int h_len;
   unsigned int v_iterations;

   /* sort coordinates if needed */
   if (sbx2 < sbx1)
     {
        JLIB_SWAP(sbx1, sbx2);
     }
   if (sby2 < sby1)
     {
        JLIB_SWAP(sby1, sby2);
     }

   /* test coordinates for "don't draw" clipping */
   if ((x > SCREEN_MAX_X) || (y > SCREEN_MAX_Y))
     {
	return;
     }

   src += (sby1 * sbuffx) + sbx1;
   dest += (y * SCREEN_WIDTH) + x;

   v_iterations = (sby2 - sby1)+1;        /* number of times to repeat horiz. blit */
   h_len = (sbx2 - sbx1)+1;       /* length of horizontal blit */

   /* test coordinates to clip area drawn */
   if (x + h_len > SCREEN_WIDTH)
     {
        h_len = SCREEN_WIDTH - x;
     }
   if (y + v_iterations > SCREEN_HEIGHT)
     {
        v_iterations = SCREEN_HEIGHT - y;
     }

	for (; v_iterations != 0; v_iterations--)
	  {
             FAST_SHORT_COPY(src, dest, h_len);
	     src += sbuffx;
	     dest += SCREEN_WIDTH;
	  }
}
