/*
** Copyright (C) 1995  Jonathan Paul Griffiths.  All rights reserved.
**
** You may do anything with this code you wish EXCEPT sell it. You may sell
** any software you create using this code,  but you MUST NOT charge for
** the code itself.  Charging a distribution fee for this code is also
** FORBIDDEN.
*/

/* WATCOM */

#include <jlib.h>
#include <stdio.h>

/*+------------------------------------------------------------------------+ */
/*|blit a fullscreen buffer to the screen                                  | */
/*+------------------------------------------------------------------------+ */
JINLINE void screen_blit_fs_buffer (buffer_rec * buff)
{
 UBYTE *out=B_BUFF_PTR(buff);
 int i;
 
 __cld();
 for(i=0;i<vesa_pages;i++){
    vesa_set_page(i*vesa_gran_mul);
    LONG_COPY((int *)out,(int *)VIDEO_START,vesa_gran1024);
    out+=vesa_gran1024;
 }

 vesa_set_page(vesa_pages);
 LONG_COPY((int *)out,(int *)VIDEO_START,vesa_remains);
 
}

/*+------------------------------------------------------------------------+ */
/*|blit part of a buffer to the screen without clipping.                   | */
/*+------------------------------------------------------------------------+ */
void screen_blit_buff_toNC (int x, int y, buffer_rec * sbuff,
			 int sbx1, int sby1, int sbx2, int sby2)
{
   int v_len = sby2 - sby1+1, h_len = sbx2 - sbx1+1;
   UBYTE *src = B_BUFF_PTR (sbuff) + (B_X_SIZE (sbuff) * sby1) + sbx1;
   UBYTE *dest = (UBYTE *)VIDEO_START;
   int width = B_X_SIZE (sbuff);
   int offset,page;

    __cld();

   offset=y*vesa_width+x;
   if(offset==0){
      page=0;
   }
   else{
      page=offset/(vesa_gran1024);
      offset=offset%(vesa_gran1024);
   }
   vesa_set_page(page*vesa_gran_mul);
   for (; v_len != 0; v_len--){
                if (offset + h_len > (vesa_gran1024))
                        if (offset >= (vesa_gran1024)) {
                                page++;
                                vesa_set_page(page*vesa_gran_mul);
                                offset=offset%(vesa_gran1024);
			}
                        else { 
                                FAST_LONG_COPY(src,dest+offset,vesa_gran1024-offset);
                                page++;
                                vesa_set_page(page*vesa_gran_mul);
                                FAST_LONG_COPY(src+vesa_gran1024-offset,dest,
                                        (offset+h_len)%vesa_gran1024);
                                offset = (offset + vesa_width)%vesa_gran1024;
				src += width;
				continue;
                        }      
                FAST_LONG_COPY(src,(UBYTE *)(VIDEO_START+offset), h_len);
                src+=width;
                offset = ((int)offset+vesa_width);
    }

}


/*+------------------------------------------------------------------------+ */
/*|blit part of a buffer to the screen with clipping.                      | */
/*+------------------------------------------------------------------------+ */

void screen_blit_buff_to (int x, int y, buffer_rec * sbuff,
			  int sbx1, int sby1, int sbx2, int sby2)
{

   int v_len = sby2 - sby1+1, h_len = sbx2 - sbx1+1;
   UBYTE *src = B_BUFF_PTR (sbuff);
   UBYTE *dest = (UBYTE *)VIDEO_START;
   int width = B_X_SIZE (sbuff);
   int offset,page;

    __cld();

   if (sbx1 > sbx2){
        JLIB_SWAP (sbx1, sbx2);
   }

   if (sby1 > sby2){
        JLIB_SWAP (sby1, sby2);
   }

   if ((x > SCREEN_MAX_X) || (y > SCREEN_MAX_Y)){
	return;
   }

   if ((x + h_len) > SCREEN_WIDTH){
	h_len = SCREEN_WIDTH - x;
   }

   if ((y + v_len) > SCREEN_HEIGHT){
	v_len = SCREEN_HEIGHT - y;
   }

   src += (B_X_SIZE (sbuff) * sby1) + sbx1;

   offset=y*vesa_width+x;
   if(offset==0){
      page=0;
   }
   else{
      page=offset/(vesa_gran1024);
      offset=offset%(vesa_gran1024);
   }
   vesa_set_page(page*vesa_gran_mul);
   for (; v_len != 0; v_len--){
                if (offset + h_len > (vesa_gran1024))
                        if (offset >= (vesa_gran1024)) {
                                page++;
                                vesa_set_page(page*vesa_gran_mul);
                                offset=offset%(vesa_gran1024);
			}
                        else { 
                                FAST_LONG_COPY(src,dest+offset,vesa_gran1024-offset);
                                page++;
                                vesa_set_page(page*vesa_gran_mul);
                                FAST_LONG_COPY(src+vesa_gran1024-offset,dest,
                                        (offset+h_len)%vesa_gran1024);
                                offset = (offset + vesa_width)%vesa_gran1024;
				src += width;
				continue;
                        }      
                FAST_LONG_COPY(src,(UBYTE *)(VIDEO_START+offset), h_len);
                src+=width;
                offset = ((int)offset+vesa_width);
    }
}



