/*
   ** Copyright (C) 1995  Jonathan Paul Griffiths.  All rights reserved.
   **
   ** You may do anything with this code you wish EXCEPT sell it. You may sell
   ** any software you create using this code,  but you MUST NOT charge for
   ** the code itself.  See the file "jlib.doc" for detailed terms. 
 */

/* target specific includes for LINUX_SVGALIB */

#ifndef __JTARGET_H__
#define __JTARGET_H__

#ifdef __cplusplus
extern "C" {
#endif 

#ifndef X_WINDOWS
#error Wrong Target header file included in build.
#endif

#include<X11/Xlib.h>

/* INPUT */
#define KEYBOARD_AVAILABLE 0    /* keyboard support not available */
#define MOUSE_AVAILABLE 0       /* mouse not available */ 
#define JOYSTICK_AVAILABLE 0    /* no joystick support */

/* mouse */
#define BUTTON_DOWN(status)  (status)

/* SCREEN */
extern Display*		jxdisplay;
extern int		jxscreen;
extern Window		jxwindow;
extern Colormap		jxcolormap;
extern GC		jxgc;

#ifdef X_320x200x256
#define  SCREEN_WIDTH   320
#define  SCREEN_HEIGHT  200
#define  SCREEN_MAX_X   319
#define  SCREEN_MAX_Y   199
#endif
#ifdef X_640x480x256
#define  SCREEN_WIDTH   640
#define  SCREEN_HEIGHT  480
#define  SCREEN_MAX_X   639
#define  SCREEN_MAX_Y   479
#endif
#ifdef X_800x600x256
#define  SCREEN_WIDTH   800
#define  SCREEN_HEIGHT  600
#define  SCREEN_MAX_X   799
#define  SCREEN_MAX_Y   599
#endif

#define  SCREEN_NUM_COLORS 256
#define  SCREEN_NUM_PAGES 1

/* MEMORY OPERATIONS */
#include <string.h>

#define get_best_copy_method(s,d,l) ALIGNMENT_STATE_1

#define ALIGNMENT_STATE_1   0
#define ALIGNMENT_STATE_2   1
#define ALIGNMENT_STATE_3   2
#define ALIGNMENT_STATE_4   3
#define ALIGNMENT_STATE_5   4
#define ALIGNMENT_STATE_6   5
#define ALIGNMENT_STATE_7   6
#define ALIGNMENT_STATE_8   7

/* every memory copy is done using memcpy */
#define MEM_COPY_ALIGN_1(x,y,z)  memcpy( (y) , (x) , (z) )
#define MEM_COPY_ALIGN_2(x,y,z)  memcpy( (y) , (x) , (z) )
#define MEM_COPY_ALIGN_3(x,y,z)  memcpy( (y) , (x) , (z) )
#define MEM_COPY_ALIGN_4(x,y,z)  memcpy( (y) , (x) , (z) )
#define MEM_COPY_ALIGN_5(x,y,z)  memcpy( (y) , (x) , (z) )
#define MEM_COPY_ALIGN_6(x,y,z)  memcpy( (y) , (x) , (z) )
#define MEM_COPY_ALIGN_7(x,y,z)  memcpy( (y) , (x) , (z) )
#define MEM_COPY_ALIGN_8(x,y,z)  memcpy( (y) , (x) , (z) )

#define FAST_SHORT_COPY(s,d,len)     memcpy( (d) , (s) , (len) )
#define FAST_LONG_COPY(s,d,len)      memcpy( (d) , (s) , (len) )
#define FAST_VERY_LONG_COPY(s,d,len) memcpy( (d) , (s) , (len) )
#define BYTE_COPY(s,d,len)           memcpy( (d) , (s) , (len) )
#define WORD_COPY(s,d,len)           memcpy( (d) , (s) , (len) )
#define LONG_COPY(s,d,len)           memcpy( (d) , (s) , (len) )

/* every memory store is done using memset */
#define MEM_STORE_ALIGN_1(d,val,len)  memset( (d) , (val) , (len) )
#define MEM_STORE_ALIGN_2(d,val,len)  memset( (d) , (val) , (len) )
#define MEM_STORE_ALIGN_3(d,val,len)  memset( (d) , (val) , (len) )
#define MEM_STORE_ALIGN_4(d,val,len)  memset( (d) , (val) , (len) )
#define MEM_STORE_ALIGN_5(d,val,len)  memset( (d) , (val) , (len) )
#define MEM_STORE_ALIGN_6(d,val,len)  memset( (d) , (val) , (len) )
#define MEM_STORE_ALIGN_7(d,val,len)  memset( (d) , (val) , (len) )
#define MEM_STORE_ALIGN_8(d,val,len)  memset( (d) , (val) , (len) )

#define FAST_SHORT_STORE(d,val,len)  memset( (d) , (val) , (len) )
#define FAST_LONG_STORE(d,val,len)   memset( (d) , (val) , (len) )
#define FAST_VERY_LONG_STORE(d,val,len) memset( (d) , (val) , (len) )
#define BYTE_STORE(d,val,len)        memset( (d) , (val) , (len) )
#define WORD_STORE(d,val,len)        memset( (d) , (val) , (len) )
#define LONG_STORE(d,val,len)        memset( (d) , (val) , (len) )

#ifdef __cplusplus
}
#endif 

#endif /* #ifndef __JTARGET_H__ */
